/*

** UART3 RS232 asynchronous communication demonstration code
** modified 5/31/2011 for N+V
**modified for U1B TX/RX 
U1BTX  BOT pin 7 PIC32 pin 49
U1BRX BOT pin 5 PIC32 pin 43
added /reset to XBEE module thk 7/15/12 BOT pin 8 RD
*/


//
#include "UART3.H"



//
// timing and baud rate calculations
#define BRATE    (FPB/4/9600)-1   // 9600 baud 
#define U_ENABLE 0x8008	            // enable UART (BREGH=1)
#define U_TX     0x1400	            // enable transmission

//modify to U1
// initialize the UART3 serial port added /reset pin 5 XBEE
// 
void initU3( void)
{
    U1BBRG 	= BRATE;    
    U1BMODE 	= U_ENABLE;
    U1BSTA 	= U_TX;
  //  TRTS    = 0;        // make RTS output
 //   RTS     = 1;        // set RTS default status
 	mPORTBSetBits(  BIT_13 );
 		mPORTBSetPinsDigitalOut(BIT_13);
} // initU2

void resetRadio(void)
{
int i =0;
    mPORTBClearBits(  BIT_13 );
	//DelayMs(5);
        // Insert some delay
		i = 512*512;
		while(i--);
		mPORTBSetBits(  BIT_13 );
	
}
int radio_Write( char *buffer, int count )
 {
	 int v=0;
  // return Serial_Write( SERIAL_0, buffer, count );
		for (v=0; v< count; v++) {

	 	//SetChar	(buffer[v]) ;
	 	putU3((int)buffer[v]);
	 }

 }
	
// send a character to the UART3 serial port
int putU3( int c)
{
   // while ( CTS);		        // wait for !CTS, clear to send
    while ( U1BSTAbits.UTXBF);   // wait while Tx buffer full
    U1BTXREG = c;
    return c;
} // putU2


// wait for a new character to arrive to the UART2 serial port ( non interrupt)
char getU3( void)
{
  //  RTS = 0;            // assert Request To Send !RTS
    while ( !U1BSTAbits.URXDA);	// wait for a new character to arrive
  //  RTS = 1;
    return U1BRXREG;		// read the character from the receive buffer
}// getU2

// send a null terminated string to the UART2 serial port
int puts( const char *s)
{
	while( *s)			// loop until *s == '\0' end of string
		putU3( *s++);	// send char and point to the next one
    putU3( '\r');       // terminate with a cr / line feed
} // putsU2

