/*

** UART3 RS232 asynchronous communication demonstration code
** modified 5/31/2011 for N+V
**modified for U1B TX/RX 
****modified for EAsy VR control 10/8/11
****modified for use with 3D Color display test

U3ARX   pin 5 JP3
U3ATX   pin 6 JP3
*/


//
#include "UART3A.H"


//
// timing and baud rate calculations
#define BRATE3    (FPB3/4/115200)-1   // 115200 baud 
//#define BRATE3    (FPB3/4/230400)-1   // 115200 baud 
#define U_ENABLE3 0x8008	            // enable UART (BREGH=1)
#define U_TX3     0x1400	            // enable transmission

//modify to U1
// initialize the UART3 serial port
void initU3A( void)
{
    U3ABRG 	= BRATE3;    
    U3AMODE 	= U_ENABLE3;
    U3ASTA 	= U_TX3;
  //  TRTS    = 0;        // make RTS output
 //   RTS     = 1;        // set RTS default status
} // initU2


// send a character to the UART3 serial port
int putU3A( int c)
{
   // while ( CTS);		        // wait for !CTS, clear to send
    while ( U3ASTAbits.UTXBF);   // wait while Tx buffer full
    U3ATXREG = c;
    return c;
} // putU2


// wait for a new character to arrive to the UART2 serial port ( non interrupt)
char getU3A( void)
{
  //  RTS = 0;            // assert Request To Send !RTS
    while ( !U3ASTAbits.URXDA);	// wait for a new character to arrive
  //  RTS = 1;
    return U3ARXREG;		// read the character from the receive buffer
}// getU2

// send a null terminated string to the UART2 serial port
int puts3A( const char *s)
{
	while( *s)			// loop until *s == '\0' end of string
		putU3A( *s++);	// send char and point to the next one
    putU3A( '\r');       // terminate with a cr / line feed
} // putsU2

