#include <plib.h>

#include "adc.h"



//modified from PIC24H chapter 5 ADC 8/14/2011 fpr PIC32

extern int raw_BOT1; //BOT pin1 analog
extern int raw_BOT2; //BOT pin 2 analog



int readADC( int ANpin)
{
	
    AD1CHS  = ANpin;               // select analog input channel based upon I/o epxansion pin
 
    AD1CON1bits.SAMP = 1;       // start sampling, automatic conversion will follow
    while (!AD1CON1bits.DONE);   // wait to complete the conversion
    return ADC1BUF0;            // read the conversion result
} // readADC

void initADC( int ANpin) 
{  
	AD1CON1bits.ADON = 0; // turn off the ADC
    AD1PCFG = 0xF8CF;    // select analog input pins
    AD1CON1 = 0x00E0;   // auto convert after end of sampling
    AD1CSSL = 0;        // no scanning required 
    AD1CON3 = 0x1F02;   // system clock,max sample time = 31Tad, Tad = 2 x Tcy = 125ns >75ns
    AD1CON2 = 0;        // use MUXA, AVss and AVdd are used as Vref+/-
    AD1CON1bits.ADON = 1; // turn on the ADC
} //initADC
//initADC must be called first
//these are  ANpin AD1CHS settings
//#define RIR  	0x00040000 // AN4Right IR
//#define LIR 	0x00050000 // AN5 Left IR
//#define VBAT 	0x00080000 // AN8 Battery power
//#define LPC 	0x00090000 // AN9 left photocell
//#define RPC 	0x000A0000 // AN10 Right photocell



void ADCoff(void) {
 AD1CON1bits.ADON = 0; // turn off the ADC	
	
}	


////
  
  

